#include <stdio.h>      /*   /  */
#include <errno.h>      /*                */
#include <sys/types.h>/*  ,   */
#include <signal.h>     /*                   */
#include <sys/wait.h>   /*   wait()           */
#include <fcntl.h>      /*  O_RDONLY              */


#include "io.h"

#define MAXARGS 100

#define LIM ':'        /*     path */

/*    path    name */
char *execat(char* path,char* name,char* buf)
//    buf
{
 register char *s = buf;
 while(*path && *path != LIM )
 *s++ = *path++;/*   */
 if( s != buf ) *s++ = '/';
 while( *name )
 *s++ = *name++; /*   */
 *s = '\0';
 return ( *path ? ++path /*  LIM */ : NULL );
}

/*        */
void callshell(char* progr,char* args[],char* envp[])
{
 register i; 
 char sh[128], *newav[MAXARGS+2];
 FILE* f; 

 if((f = fopen(progr,"r"))!=0)
 {
  if(fgetc(f)!='#') return; 
  if(fgetc(f)!='!') return;
  fgets(sh,128,f); 
  sh[strlen(sh)-1]=0;
  fclose(f);
 }
 else return;
        newav[0] = "Shellscript";
        newav[1] = progr; 
        for(i=1; args[i]; i++)
 newav[i+1] = args[i];
        newav[i+1] = NULL;
	    
        execve(sh, newav, envp);
}

/*    ,   . */
void dowait()
{
 int ws; int pid;

 while((pid = wait( &ws)) > 0 )
 {
  if( WIFEXITED(ws))
  {/* printf( "yash:  %d    %d.\n",
pid,WEXITSTATUS(ws));
*/}
  else if( WIFSIGNALED(ws))
       {
         printf( "yash:  %d    %d.\n",
pid,WTERMSIG(ws));
         if(WCOREDUMP(ws)) printf( "yash:  core   %i.\n",pid);
       }else if( WIFSTOPPED(ws))
       {
        printf( "yash:  %d     %d.\n",
pid,WSTOPSIG(ws));
       }
 }
}

/*        PATH */
int execvpe(char* progr,char **av,char **envp)
{
 char *path, *cp;
 int try = 1;
 register eacces = 0;
 char fullpath[256]; /*    */

 if((path =(char*) getenv("PATH")) == NULL )
 path = ".:/bin:/usr/bin:/etc";
 /* :      ? */
 cp = strchr(progr, '/') ? "" : path;
 do{     /*    */
    cp = (char*)execat(cp, progr, fullpath);
 retry:
    execve(fullpath, av, envp);
    /*   ,     
     *    .  - . */
    switch( errno ){  /*    ? */
    case ENOEXEC:  /*    */
     callshell(fullpath, av, envp);
     return (1);
    case ETXTBSY:   /*   */
     if( ++try > 5 ) return (-1);
  sleep(try); goto retry;
    case EACCES:  eacces++; break;  /*    */
 
    case ENOMEM:    /*      */
    case E2BIG:
 return (-1);
  }// case
 }while( cp );
 if( eacces ) errno = EACCES;
 return (-1);
}

int cmdExec(char* progr,char** av,char** envp)
/*   */
{
 void (*del)(), (*quit)(); //   
 register i, 
          chpid; // # ģ 
//	  cterm; // 
 int cr = 0;
 // output   :    

 del = signal(SIGINT, SIG_IGN); quit = signal(SIGQUIT, SIG_IGN);
 
 if( ! (chpid = fork())) /*  */
 {      /*   () */
         signal(SIGINT, SIG_DFL); /*   */
         signal(SIGQUIT,SIG_DFL); /*           */
        /* getpid()   ()   */
//	pid = getpid();
   
/*     -  ,      */
   if( fone && !outp )  outp = "/dev/null", outflg = 0;
   if( fone && !inp ) inp = "/dev/null"; 
/*        */   

   /*  - */
   
   if( inp ) if(!input( inp ))
   { 
    fprintf(stderr, "yash::    <%s\n", inp ); goto Err;
   }
   if( outp )
       if(!output (outp, outflg & APPEND, outflg & ERRTOO, &cr))
       {
         fprintf(stderr, "yash::    >%s\n", outp ); goto Err;
       }

     /*  :  
      *   ,    
      *  main(ac, av, envp) ,    progr.
      * ac  .
 */
 
i=execvpe(progr, av, envp);/*         */
 
   if(i==1) fprintf(stderr,"yash:  `%s` -   .",av[0]);
   else
    if(errno==ENOENT) fprintf(stderr,"yash:     `%s`.\n",av[0]);
    else printf("yash: %s\n",strerror(errno));
    exit(errno); //   
    
 Err:
   if( cr && outp )  /*         */
       unlink(outp); /*       */
   exit(errno); /*    */
 }
 else  
 {
  if( !fone )  dowait();/*    ,  ģ  */
 }

    /*   , wait    
     *    */
 
 signal(SIGINT, del); /*       */
 signal(SIGQUIT, quit);
 return chpid;     /*    */
}

