#include <stdio.h>      /*   /  */
#include <signal.h>     /*                   */
#include <ctype.h>      /*         */
#include <dirent.h>     /*    BSD 4.2 */
#include <pwd.h>        /*   /etc/passwd              */

#include "cmdline.h"
#include "tok.h"
#include "exec.h"
#include "io.h"
#include "cat.h"

void sigCtrlC(int sig,siginfo_t* info, void* n)//   SIGINT
{char c;
 printf("yash:   SIGINT   %d\n",info->si_pid);
 printf("yash:   yash? y/n: "); c=getchar(); 
 if(c=='y'||c=='Y')  printf("%c\n",c), exit(0);
 else if(c=='n'||c=='N') printf("%c\n",c), prompt(); 
}

void setcwd() /*     */
{
 char cwd[512];
 getcwd(cwd,512); setenv( "CWD", cwd );
}

main(int ac,char** av)
{
 char *user = "root";      /*       */
 char *home = "/root";     /*    */
 int uid = getuid(); //  uid
 struct passwd *p = getpwuid(uid); // -  
  uid
 register i; // ޣ   
 register cat_on = 1;
 
 if(ac>1 && strcmp(av[1],"-c")==0) cat_on = 0;
 
 if( p != NULL )
 {
    if(p->pw_name && *p->pw_name ) user = p->pw_name;
    if(               *p->pw_dir ) home = p->pw_dir;
 }
 setenv("USER", user); setenv("HOME", home);
 setenv("home", home); setenv("path", ".:/bin:/sbin:/usr/bin:/usr/sbin");

 setenv("status","0");
 
 { //   .
    struct sigaction s2,musor;
    s2.sa_sigaction=sigCtrlC;
    s2.sa_flags=SA_SIGINFO;
    sigaction(2,&s2,&musor);
 }
 
 for(i=0; i<MAXARGS; i++) args[i]=NULL;
 
 for(;;)
 {/*       */ 
#define ioopen if( outp )\
    if((fp = fopen(outp, outflg & APPEND ? "a":"w"))
 == NULL)\
    {\
     fprintf(stderr,"yash:     %s\n",outp);\
     continue;
\
    }
   
#define ioclose if( fp != stdout ) fclose(fp);

  FILE* fp = stdout; //       
  
  char *s; //    

  s = getcmd(); //   
  
  tok(s); // ߣ   
  
  if(argn==0) continue;

  if(cat_on && strcmp(args[0],"cat")==0) 
  {
   ioopen; // io  
   cat(argn,args,fp);
   ioclose; // io   
   continue;
  }
  if(strcmp(args[0],"logout")==0) exit(0);
  if(strcmp(args[0],"exit")==0) puts("yash:  yash ۣ"), exit(0);
  if(strcmp(args[0],"date")==0)
  {
   int try; 
   ioopen; // io
   time(&try); fprintf(fp,"%s",ctime(&try)); 
   ioclose; // io
   continue;
  }
  if(strcmp(args[0],"pwd")==0)
  {
#define CS 516   
   char gdir[CS];
   ioopen; // io
    fprintf(fp,"%s\n",getcwd(gdir,CS)); 
   ioclose; // io
#undef CS   
   continue;
  }
  if(strcmp(args[0], "cd" )==0)
  {
   char *d = (argn==1) ? (char*)getenv("HOME"):args[1];
   if(chdir(d) < 0)
 fprintf(stderr,"yash:     `%s`\n", d );
 else setcwd();
   continue;
  }
  if(strcmp(args[0], "cd.." )==0) { chdir(".."); setcwd();
 continue;}
  if(strcmp(args[0], "echo" )==0) 
  {
   ioopen;  // io
   for(i=1; i<argn; i++)  fprintf(fp,"%s%c",args[i],argn==i+1 ? '\n':' ');
   ioclose; // io
   continue;
  } 
  if(strcmp(args[0], "mdir" )==0) 
  {
   struct dirent *ep;
   char* dname = argn>1 ? args[1]:"./";
   DIR* dp = opendir(dname);
   ioopen;   // io
   if(dp!=0)
   {
    while(ep = readdir(dp)) //    ep->d_ino;
     if(strcmp(ep->d_name,"..") && strcmp(ep->d_name,".")) 
     fprintf(fp,"%s\t",ep->d_name);
    closedir(dp);     
     fprintf(fp,"\n");
   }  else fprintf(stderr,"yash:  `%s`  .\n",dname);
   ioclose; // io
   continue;
  }

  if(strcmp(args[0], "set" )==0)   
  {
   if(argn==1)  printv();  else  setv();
   continue;
  }
  if(strcmp(args[0], "unset" )==0) 
  {
   if(args[1]) unsetvar(args[1]);
   continue;
  }  
  if(s=(char*)strchr(args[0],'='))
  {
   *s++='\0';
   setvar( args[0], s? s:""); //   
   continue;
  }
  if(strcmp(args[0],"getenv")==0) //  
  {
   for(i=0; environ[i]; i++) 
   { register j=19;
     if(i==j) printf("\t\t\t\t  *****"), getchar(), j+=19;
     printf("%s\n",environ[i]);
   }
   continue; 
  }
  if(strcmp(args[0],"setenv")==0)
  { /*    */
   if(argn>1) setenv(args[1],(char*)strdup(findvar(args[1])));
   continue;
  }
  
   cmdExec(args[0],args,environ); //   
 }
}
